(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('loisolire-au-input-angular-library', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory((global.ng = global.ng || {}, global.ng.LoisolireAuInputAngularLibrary = {}), global.ng.core, global.ng.common));
}(this, function (exports, core, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @license loisolire-au-input-angular-library
     * MIT license
     */

    var InputSearchDirective = /** @class */ (function () {
        function InputSearchDirective() {
            this.focus = false;
        }
        InputSearchDirective.prototype.onFocus = function () {
            this.focus = true;
        };
        InputSearchDirective.prototype.onBlur = function () {
            this.focus = false;
        };
        __decorate([
            core.HostListener('focus'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], InputSearchDirective.prototype, "onFocus", null);
        __decorate([
            core.HostListener('blur'),
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], InputSearchDirective.prototype, "onBlur", null);
        InputSearchDirective = __decorate([
            core.Directive({
                selector: 'au-fa-input input'
            }),
            __metadata("design:paramtypes", [])
        ], InputSearchDirective);
        return InputSearchDirective;
    }());

    var AuFaInputComponent = /** @class */ (function () {
        function AuFaInputComponent() {
            this.icon = '';
        }
        Object.defineProperty(AuFaInputComponent.prototype, "focus", {
            get: function () {
                return this.input ? this.input.focus : false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AuFaInputComponent.prototype, "classes", {
            get: function () {
                var cssClasses = {};
                if (this.icon) {
                    cssClasses['fa-' + this.icon] = true;
                }
                return cssClasses;
            },
            enumerable: true,
            configurable: true
        });
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], AuFaInputComponent.prototype, "icon", void 0);
        __decorate([
            core.ContentChild(InputSearchDirective, { static: false }),
            __metadata("design:type", InputSearchDirective)
        ], AuFaInputComponent.prototype, "input", void 0);
        __decorate([
            core.HostBinding('class.input-search-focus'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], AuFaInputComponent.prototype, "focus", null);
        AuFaInputComponent = __decorate([
            core.Component({
                selector: 'au-fa-input',
                template: "<i [ngClass]=\"classes\" class=\"fa icon\"></i>\r\n<ng-content></ng-content>\r\n",
                styles: ["i {\n  width: 25px;\n  text-align: center;\n  padding: 0 2px 0 5px;\n  border: none; }\n\n:host {\n  border-width: 1px;\n  border-style: solid;\n  padding: 1px 0;\n  display: inline-block;\n  height: 30px; }\n  :host ::ng-deep input {\n    vertical-align: middle;\n    border: none;\n    outline: none;\n    height: 100%;\n    margin: 1px 0;\n    box-sizing: border-box; }\n  :host i {\n    vertical-align: middle; }\n  :host .input-search-focus {\n    outline: none;\n    border-width: 1px;\n    border-style: solid; }\n\n:host-context(.au-fa-input-red-theme) {\n  border-color: red; }\n  :host-context(.au-fa-input-red-theme).input-search-focus {\n    border-color: red;\n    -webkit-box-shadow: 0 0 5px red;\n    box-shadow: 0 0 5px red; }\n\n:host {\n  border-color: lightgray;\n  background: white; }\n  :host.input-search-focus {\n    border-color: #4D90FE;\n    -webkit-box-shadow: 0 0 5px #4D90FE;\n    box-shadow: 0 0 5px #4D90FE; }\n"]
            }),
            __metadata("design:paramtypes", [])
        ], AuFaInputComponent);
        return AuFaInputComponent;
    }());

    var AuMdInputComponent = /** @class */ (function () {
        function AuMdInputComponent() {
            this.icon = '';
        }
        Object.defineProperty(AuMdInputComponent.prototype, "focus", {
            get: function () {
                return this.input ? this.input.focus : false;
            },
            enumerable: true,
            configurable: true
        });
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], AuMdInputComponent.prototype, "icon", void 0);
        __decorate([
            core.ContentChild(InputSearchDirective, { static: false }),
            __metadata("design:type", InputSearchDirective)
        ], AuMdInputComponent.prototype, "input", void 0);
        __decorate([
            core.HostBinding('class.input-search-focus'),
            __metadata("design:type", Boolean),
            __metadata("design:paramtypes", [])
        ], AuMdInputComponent.prototype, "focus", null);
        AuMdInputComponent = __decorate([
            core.Component({
                selector: 'au-md-input',
                template: "<i class=\"material-icons md-18\" [innerHTML]=\"icon\"></i>\r\n<ng-content></ng-content>\r\n",
                styles: ["i {\n  width: 25px;\n  text-align: center;\n  padding: 0 2px 0 5px;\n  border: none; }\n\n:host {\n  border-width: 1px;\n  border-style: solid;\n  padding: 1px 0;\n  display: inline-block;\n  height: 30px; }\n  :host ::ng-deep input {\n    vertical-align: middle;\n    border: none;\n    outline: none;\n    height: 100%;\n    margin: 1px 0;\n    box-sizing: border-box; }\n  :host i {\n    vertical-align: middle; }\n  :host .input-search-focus {\n    outline: none;\n    border-width: 1px;\n    border-style: solid; }\n\n:host-context(.au-fa-input-red-theme) {\n  border-color: red; }\n  :host-context(.au-fa-input-red-theme).input-search-focus {\n    border-color: red;\n    -webkit-box-shadow: 0 0 5px red;\n    box-shadow: 0 0 5px red; }\n\n:host {\n  border-color: lightgray;\n  background: white; }\n  :host.input-search-focus {\n    border-color: #4D90FE;\n    -webkit-box-shadow: 0 0 5px #4D90FE;\n    box-shadow: 0 0 5px #4D90FE; }\n"]
            }),
            __metadata("design:paramtypes", [])
        ], AuMdInputComponent);
        return AuMdInputComponent;
    }());

    var AuInputModule = /** @class */ (function () {
        function AuInputModule() {
        }
        AuInputModule = __decorate([
            core.NgModule({
                imports: [common.CommonModule],
                declarations: [AuFaInputComponent, InputSearchDirective, AuMdInputComponent],
                exports: [AuFaInputComponent, InputSearchDirective, AuMdInputComponent]
            })
        ], AuInputModule);
        return AuInputModule;
    }());

    exports.AuFaInputComponent = AuFaInputComponent;
    exports.AuInputModule = AuInputModule;
    exports.AuMdInputComponent = AuMdInputComponent;
    exports.InputSearchDirective = InputSearchDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=loisolire-au-input-angular-library.umd.js.map
